package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ConfRestricaoTramoOCDAO;
import com.rjconsultores.ventaboletos.entidad.ConfRestricaoTramoOC;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.service.ConfRestricaoTramoOCService;
import com.rjconsultores.ventaboletos.service.ParadaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("confRestricaoTramoOCService")
public class ConfRestricaoTramoOCServiceImpl implements ConfRestricaoTramoOCService {

	@Autowired
	ConfRestricaoTramoOCDAO confRestricaoTramoOCDAO;
	@Autowired
	private ParadaService paradaService;

	@Override
	public List<ConfRestricaoTramoOC> obtenerTodos() {
		return confRestricaoTramoOCDAO.obtenerTodos();
	}

	@Override
	public ConfRestricaoTramoOC obtenerID(Integer id) {
		return confRestricaoTramoOCDAO.obtenerID(id);
	}

	@Override
	public ConfRestricaoTramoOC obtenerTramoOCTodos() {

		ConfRestricaoTramoOC entidad = new ConfRestricaoTramoOC();

		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);
		Parada parada = paradaService.obtenerID(-1);
		entidad.setOrigem(parada);
		entidad.setDestino(parada);
		return entidad;
	}

	@Override
	@Transactional
	public ConfRestricaoTramoOC suscribir(ConfRestricaoTramoOC entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return confRestricaoTramoOCDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public ConfRestricaoTramoOC actualizacion(ConfRestricaoTramoOC entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return confRestricaoTramoOCDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(ConfRestricaoTramoOC entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		confRestricaoTramoOCDAO.actualizacion(entidad);
	}
}
